# SoCube Class Reference
[Nodes]

`#include <Inventor/nodes/SoCube.h>`

Inheritance diagram for SoCube:

List of all members.

## Detailed Description

The SoCube class is for rendering cubes.

Insert a cube shape into the scenegraph. The cube is rendered with the current material, texture and drawstyle settings (if any, otherwise the default settings are used).

(Strictly speaking, as you can have different width, height and depth values for the "cube", instances of this class actually represents boxes.)

The SoCube node class is provided as a convenient abstraction for the application programmer to use "complex" shapes of this type without having to do the calculation and book-keeping of the polygon sides and other low-level programming herself.

See also:
  SoCylinder, SoSphere, SoCone

## Public Member Functions

| SoCube (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFFloat | width
SoSFFloat | height
SoSFFloat | depth

## Protected Member Functions

virtual | ~SoCube ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

## Constructor & Destructor Documentation

SoCube::SoCube | ( | void |  | ) |

| Constructor.

SoCube::~SoCube | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoCube::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoShape.

void SoCube::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoCube::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoCube::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoCube::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

void SoCube::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

## Member Data Documentation

SoSFFloat SoCube::width

| X axis dimension of cube, defaults to 2.0.

SoSFFloat SoCube::height

| Y axis dimension of cube, defaults to 2.0.

SoSFFloat SoCube::depth

| Z axis dimension of cube, defaults to 2.0.

The documentation for this class was generated from the following files:

- SoCube.h
- SoCube.cpp